﻿Imports System.Net
Imports System.Environment

Public Class Form1

    Private WithEvents webclient As WebClient

    Dim sGUID As String

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
#Region "Update_Check und InternetConnection()"

        '----
        If InternetConnection() = False Then
            Dim nointernet = MessageBox.Show("You are not connected to the internet. If you start Theme Manager without an internet connection, you are not able to use all features and the application won't works correctly." + vbNewLine + vbNewLine + "Do you want to start without an internet connection?", "Warning: No Internet Connection", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
            If nointernet = DialogResult.No Then
                Me.Close()

            End If

            If nointernet = DialogResult.Yes Then
                Me.Show()
                FastColoredTextBox1.ReadOnly = True
                lbl_guid.Visible = False
                lbl_nointernet.Visible = True
                MsgBox("You have started Theme Manager without an internet connection.", MsgBoxStyle.Information, "Information: No Internet")
            End If

        Else

            'Versions-Check
            Dim request_u As System.Net.HttpWebRequest = System.Net.WebRequest.Create("https://theme-manager.xyz/automatic/Version.txt")
            Dim response_u As System.Net.HttpWebResponse = request_u.GetResponse
            Dim reader_u As System.IO.StreamReader = New System.IO.StreamReader(response_u.GetResponseStream)
            Dim newest As String = reader_u.ReadToEnd
            Dim current As String = version.Text

            'Killswitch-Check
            Dim request_k As System.Net.HttpWebRequest = System.Net.WebRequest.Create("https://theme-manager.xyz/automatic/Killswitch.txt")
            Dim response_k As System.Net.HttpWebResponse = request_k.GetResponse
            Dim reader_k As System.IO.StreamReader = New System.IO.StreamReader(response_k.GetResponseStream)
            Dim on_off As String = reader_k.ReadToEnd

            If on_off.Contains("online") Then
                MsgBox("Huh? Sorry, but Theme Manager is currently not available due to an critical error." + vbNewLine + "Please try again later!", MsgBoxStyle.Exclamation, "Warning: Service unavailable")
                Me.Close()

            Else

                If Not newest.Contains(current) Then
                    Dim update = MessageBox.Show("A new update is available and cool new features!" + vbNewLine + "Do you want to update?", "Question: Update?", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
                    If update = DialogResult.No Then
                        Me.Show()

                        MsgBox("Warning: You are not Up-To-Date! It is recommended to update." + vbNewLine + "To do this, just restart Theme Manager.", MsgBoxStyle.Exclamation, "Warning: Not Up-To-Date")
                    End If

                    If update = DialogResult.Yes Then

                        tHide.Interval = 10
                        tHide.Start()

                        Me.Hide()
                        prepareupdate.Show()
                        Me.Hide()
                    End If

                Else

                    Try

                        sGUID = System.Guid.NewGuid.ToString


                        Threading.Thread.Sleep(250)
                        webclient = New WebClient
                        webclient.DownloadString(New Uri("https://theme-manager.xyz/api/count.php?uid=USR-" + sGUID))


                        Me.Hide()
                        Me.Opacity = 0.0

                        For i = 0.0 To 10.0 Step 0.01
                            If Me.Opacity < 1.0 Then
                                Me.Opacity += 0.01
                                Threading.Thread.Sleep(10)

                            End If
                        Next
                        FastColoredTextBox1.ReadOnly = True
                        lbl_guid.Text = sGUID

                        For Each eintrag As String In My.Settings.favorites
                            ListBox3.Items.Add(eintrag)
                        Next

                    Catch ex As Exception
                        MsgBox("An unexpected error occured." + vbNewLine + vbNewLine + ex.Message, MsgBoxStyle.Critical, "Error: Unexpected error")
                        Me.Close()

                    End Try

                End If
            End If
        End If
    End Sub

    Private Function InternetConnection() As Boolean
        Dim request_i As System.Net.WebRequest = System.Net.WebRequest.Create("https://www.google.de")
        Dim response_i As System.Net.WebResponse

        Try
            response_i = request_i.GetResponse
            response_i.Close()
            request_i = Nothing
            Return True

        Catch ex As Exception
            request_i = Nothing
            Return False

        End Try
    End Function
#End Region

    Private Sub Label2_Click(sender As Object, e As EventArgs)
        Process.Start("https://theme-manager.xyz/news/offline")

    End Sub

    Private Sub tHide_Tick(sender As Object, e As EventArgs) Handles tHide.Tick
        tHide.Interval = 500
        Me.Hide()

    End Sub

    Private Sub btn_changelog_Click(sender As Object, e As EventArgs) Handles btn_changelog.Click
        changelog.Show()

    End Sub

    Private Sub Label11_Click(sender As Object, e As EventArgs) Handles Label11.Click
        Process.Start("https://theme-manager.xyz/support")

    End Sub

#Region "-> All Themes <-"
    Private Sub ListBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListBox1.SelectedIndexChanged
        Select Case ListBox1.SelectedIndex
            Case 0
                Me.Screenshot.Image = My.Resources.Adobe
                My.Settings.Theme = My.Resources.Adobe_C
            Case 1
                Me.Screenshot.Image = My.Resources.Advantium
                My.Settings.Theme = My.Resources.Advantium_C
            Case 2
                Me.Screenshot.Image = My.Resources.Aevion
                My.Settings.Theme = My.Resources.Aevion_C
            Case 3
                Me.Screenshot.Image = My.Resources.Anom
                My.Settings.Theme = My.Resources.Anom_C
            Case 4
                Me.Screenshot.Image = My.Resources.Aresio
                My.Settings.Theme = My.Resources.Aresio_C
            Case 5
                Me.Screenshot.Image = My.Resources.AVG
                My.Settings.Theme = My.Resources.AVG_C
            Case 6
                Me.Screenshot.Image = My.Resources.BasicCode
                My.Settings.Theme = My.Resources.BasicCode_C
            Case 7
                Me.Screenshot.Image = My.Resources.BetaBlue
                My.Settings.Theme = My.Resources.BetaBlue_C
            Case 8
                Me.Screenshot.Image = My.Resources.Beyond
                My.Settings.Theme = My.Resources.Beyond_C
            Case 9
                Me.Screenshot.Image = My.Resources.BitDefender
                My.Settings.Theme = My.Resources.BitDefender_C
            Case 10
                Me.Screenshot.Image = My.Resources.Black_V1
                My.Settings.Theme = My.Resources.Black_V1_C
            Case 11
                Me.Screenshot.Image = My.Resources.Black_V2
                My.Settings.Theme = My.Resources.Black_V2_C
            Case 12
                Me.Screenshot.Image = My.Resources.Bloody
                My.Settings.Theme = My.Resources.Bloody_C
            Case 13
                Me.Screenshot.Image = My.Resources.CarbonFiber
                My.Settings.Theme = My.Resources.CarbonFiber_C
            Case 14
                Me.Screenshot.Image = My.Resources.Carbonite
                My.Settings.Theme = My.Resources.Carbonite_C
            Case 15
                Me.Screenshot.Image = My.Resources.Chrome
                My.Settings.Theme = My.Resources.Chrome_C
            Case 16
                Me.Screenshot.Image = My.Resources.Classic
                My.Settings.Theme = My.Resources.Classic_C
            Case 17
                Me.Screenshot.Image = My.Resources.CocaCola
                My.Settings.Theme = My.Resources.CocaCola_C
            Case 18
                Me.Screenshot.Image = My.Resources.CryEngine
                My.Settings.Theme = My.Resources.CryEngine_C
            Case 19
                Me.Screenshot.Image = My.Resources.DarkMatter
                My.Settings.Theme = My.Resources.DarkMatter_C
            Case 20
                Me.Screenshot.Image = My.Resources.Deimos
                My.Settings.Theme = My.Resources.Deimos_C
            Case 21
                Me.Screenshot.Image = My.Resources.Destiny
                My.Settings.Theme = My.Resources.Destiny_C
            Case 22
                Me.Screenshot.Image = My.Resources.Deumos
                My.Settings.Theme = My.Resources.Deumos_C
            Case 23
                Me.Screenshot.Image = My.Resources.Doom
                My.Settings.Theme = My.Resources.Doom_C
            Case 24
                Me.Screenshot.Image = My.Resources.Drone
                My.Settings.Theme = My.Resources.Drone_C
            Case 25
                Me.Screenshot.Image = My.Resources.DynamUI
                My.Settings.Theme = My.Resources.DynamUI_C
            Case 26
                Me.Screenshot.Image = My.Resources.E
                My.Settings.Theme = My.Resources.E_C
            Case 27
                Me.Screenshot.Image = My.Resources.Earn
                My.Settings.Theme = My.Resources.Earn_C
            Case 28
                Me.Screenshot.Image = My.Resources.Effectual
                My.Settings.Theme = My.Resources.Effectual_C
            Case 29
                Me.Screenshot.Image = My.Resources.EightBall
                My.Settings.Theme = My.Resources.EightBall_C
            Case 30
                Me.Screenshot.Image = My.Resources.Electric
                My.Settings.Theme = My.Resources.Electric_C
            Case 31
                Me.Screenshot.Image = My.Resources.Electrified
                My.Settings.Theme = My.Resources.Electrified_C
            Case 32
                Me.Screenshot.Image = My.Resources.Elegant
                My.Settings.Theme = My.Resources.Elegant_C
            Case 33
                Me.Screenshot.Image = My.Resources.Elementary
                My.Settings.Theme = My.Resources.Elementary_C
            Case 34
                Me.Screenshot.Image = My.Resources.FacebookGDI
                My.Settings.Theme = My.Resources.FacebookGDI_C
            Case 35
                Me.Screenshot.Image = My.Resources.FlatUI
                My.Settings.Theme = My.Resources.FlatUI_C
            Case 36
                Me.Screenshot.Image = My.Resources.Frog
                My.Settings.Theme = My.Resources.Frog_C
            Case 37
                Me.Screenshot.Image = My.Resources.FrostByte
                My.Settings.Theme = My.Resources.FrostByte_C
            Case 38
                Me.Screenshot.Image = My.Resources.Fusion
                My.Settings.Theme = My.Resources.Fusion_C
            Case 39
                Me.Screenshot.Image = My.Resources.GameBooster
                My.Settings.Theme = My.Resources.GameBooster_C
            Case 40
                Me.Screenshot.Image = My.Resources.Genesis
                My.Settings.Theme = My.Resources.Genesis_C
            Case 41
                Me.Screenshot.Image = My.Resources.Ghost_V1
                My.Settings.Theme = My.Resources.Ghost_V1_C
            Case 42
                Me.Screenshot.Image = My.Resources.Ghost_V2
                My.Settings.Theme = My.Resources.Ghost_V2_C
            Case 43
                Me.Screenshot.Image = My.Resources.Gray_Blue
                My.Settings.Theme = My.Resources.Gray_Blue_C
            Case 449
                Me.Screenshot.Image = My.Resources.Hacker
                My.Settings.Theme = My.Resources.Hacker_C
            Case 45
                Me.Screenshot.Image = My.Resources.Heaven
                My.Settings.Theme = My.Resources.Heaven_C
            Case 46
                Me.Screenshot.Image = My.Resources.HF
                My.Settings.Theme = My.Resources.HF_C
            Case 47
                Me.Screenshot.Image = My.Resources.Hura_Dark
                My.Settings.Theme = My.Resources.Hura_Dark_C
            Case 48
                Me.Screenshot.Image = My.Resources.Hura_Light
                My.Settings.Theme = My.Resources.Hura_Light_C
            Case 49
                Me.Screenshot.Image = My.Resources.Hurrycan
                My.Settings.Theme = My.Resources.Hurrycan_C
            Case 50
                Me.Screenshot.Image = My.Resources.Influx
                My.Settings.Theme = My.Resources.Influx_C
            Case 51
                Me.Screenshot.Image = My.Resources.Light
                My.Settings.Theme = My.Resources.Light_C
            Case 52
                Me.Screenshot.Image = My.Resources.LogIn
                My.Settings.Theme = My.Resources.LogIn_C
            Case 53
                Me.Screenshot.Image = My.Resources.MetroDisk
                My.Settings.Theme = My.Resources.MetroDisk_C
            Case 54
                Me.Screenshot.Image = My.Resources.NetSeal
                My.Settings.Theme = My.Resources.NetSeal_C
            Case 55
                Me.Screenshot.Image = My.Resources.Origin
                My.Settings.Theme = My.Resources.Origin_C
            Case 56
                Me.Screenshot.Image = My.Resources.OriginGDI
                My.Settings.Theme = My.Resources.OriginGDI_C
            Case 57
                Me.Screenshot.Image = My.Resources.Perplex
                My.Settings.Theme = My.Resources.Perplex_C
            Case 58
                Me.Screenshot.Image = My.Resources.Phsphene
                My.Settings.Theme = My.Resources.Phsphene_C
            Case 59
                Me.Screenshot.Image = My.Resources.Piano
                My.Settings.Theme = My.Resources.Piano_C
            Case 60
                Me.Screenshot.Image = My.Resources.Positron
                My.Settings.Theme = My.Resources.Positron_C
            Case 61
                Me.Screenshot.Image = My.Resources.Pv
                My.Settings.Theme = My.Resources.Pv_C
            Case 62
                Me.Screenshot.Image = My.Resources.Reactor
                My.Settings.Theme = My.Resources.Reactor_C
            Case 63
                Me.Screenshot.Image = My.Resources.Recon
                My.Settings.Theme = My.Resources.Recon_C
            Case 64
                Me.Screenshot.Image = My.Resources.Recuperare
                My.Settings.Theme = My.Resources.Recuperare_C
            Case 65
                Me.Screenshot.Image = My.Resources.Redemption
                My.Settings.Theme = My.Resources.Redemption_C
            Case 66
                Me.Screenshot.Image = My.Resources.Rockstar
                My.Settings.Theme = My.Resources.Rockstar_C
            Case 67
                Me.Screenshot.Image = My.Resources.Sasi
                My.Settings.Theme = My.Resources.Sasi_C
            Case 68
                Me.Screenshot.Image = My.Resources.Secure
                My.Settings.Theme = My.Resources.Secure_C
            Case 69
                Me.Screenshot.Image = My.Resources.Sharp
                My.Settings.Theme = My.Resources.Sharp_C
            Case 70
                Me.Screenshot.Image = My.Resources.Simpla
                My.Settings.Theme = My.Resources.Simpla_C
            Case 71
                Me.Screenshot.Image = My.Resources.SkyDark
                My.Settings.Theme = My.Resources.SkyDark_C
            Case 72
                Me.Screenshot.Image = My.Resources.Skype
                My.Settings.Theme = My.Resources.Skype_C
            Case 73
                Me.Screenshot.Image = My.Resources.SLC
                My.Settings.Theme = My.Resources.SLC_C
            Case 74
                Me.Screenshot.Image = My.Resources.Steam
                My.Settings.Theme = My.Resources.Steam_C
            Case 75
                Me.Screenshot.Image = My.Resources.Studio
                My.Settings.Theme = My.Resources.Studio_C
            Case 76
                Me.Screenshot.Image = My.Resources.Subspace
                My.Settings.Theme = My.Resources.Subspace_C
            Case 77
                Me.Screenshot.Image = My.Resources.Sweet
                My.Settings.Theme = My.Resources.Sweet_C
            Case 78
                Me.Screenshot.Image = My.Resources.Teamviewer
                My.Settings.Theme = My.Resources.Teamviewer_C
            Case 79
                Me.Screenshot.Image = My.Resources.Tennis
                My.Settings.Theme = My.Resources.Tennis_C
            Case 80
                Me.Screenshot.Image = My.Resources.TheEmpire
                My.Settings.Theme = My.Resources.TheEmpire_C
            Case 81
                Me.Screenshot.Image = My.Resources.Thirteen
                My.Settings.Theme = My.Resources.Thirteen_C
            Case 82
                Me.Screenshot.Image = My.Resources.Tlf
                My.Settings.Theme = My.Resources.Tlf_C
            Case 83
                Me.Screenshot.Image = My.Resources.Twitch
                My.Settings.Theme = My.Resources.Twitch_C
            Case 84
                Me.Screenshot.Image = My.Resources.Ubuntu
                My.Settings.Theme = My.Resources.Ubuntu_C
            Case 85
                Me.Screenshot.Image = My.Resources.Uclear
                My.Settings.Theme = My.Resources.Uclear_C
            Case 86
                Me.Screenshot.Image = My.Resources.UPlay
                My.Settings.Theme = My.Resources.UPlay_C
            Case 87
                Me.Screenshot.Image = My.Resources.Valley
                My.Settings.Theme = My.Resources.Valley_C
            Case 88
                Me.Screenshot.Image = My.Resources.VI
                My.Settings.Theme = My.Resources.VI_C
            Case 89
                Me.Screenshot.Image = My.Resources.Vibe
                My.Settings.Theme = My.Resources.Vibe_C
            Case 90
                Me.Screenshot.Image = My.Resources.VisualStudio
                My.Settings.Theme = My.Resources.VisualStudio_C
            Case 91
                Me.Screenshot.Image = My.Resources.Vitality
                My.Settings.Theme = My.Resources.Vitality_C
            Case 92
                Me.Screenshot.Image = My.Resources.Vizual
                My.Settings.Theme = My.Resources.Vizual_C
            Case 93
                Me.Screenshot.Image = My.Resources.WhiteUI
                My.Settings.Theme = My.Resources.WhiteUI_C
            Case 94
                Me.Screenshot.Image = My.Resources.Xbox
                My.Settings.Theme = My.Resources.Xbox_C
            Case 95
                Me.Screenshot.Image = My.Resources.XtremeInc
                My.Settings.Theme = My.Resources.XtremeInc_C
            Case 96
                Me.Screenshot.Image = My.Resources.YouTubeGDI
                My.Settings.Theme = My.Resources.YouTubeGDI_C
            Case 97
                Me.Screenshot.Image = My.Resources.Alpha
                My.Settings.Theme = My.Resources.Alpha_C
            Case 98
                Me.Screenshot.Image = My.Resources.Avast
                My.Settings.Theme = My.Resources.Avast_C
            Case 99
                Me.Screenshot.Image = My.Resources.Inj3ct0r
                My.Settings.Theme = My.Resources.Inj3ct0r_C
            Case 100
                Me.Screenshot.Image = My.Resources.NYX
                My.Settings.Theme = My.Resources.NYX_C
            Case 101
                Me.Screenshot.Image = My.Resources.V
                My.Settings.Theme = My.Resources.V_C
            Case 102
                Me.Screenshot.Image = My.Resources.Azenis
                My.Settings.Theme = My.Resources.Azenis_C
            Case 103
                Me.Screenshot.Image = My.Resources.Bonfire
                My.Settings.Theme = My.Resources.Bonfire_C
            Case 104
                Me.Screenshot.Image = My.Resources.Exotic
                My.Settings.Theme = My.Resources.Exotic_C
            Case 105
                Me.Screenshot.Image = My.Resources.Future
                My.Settings.Theme = My.Resources.Future_C
            Case 106
                Me.Screenshot.Image = My.Resources.Basic
                My.Settings.Theme = My.Resources.Basic_C
            Case 107
                Me.Screenshot.Image = My.Resources.Calvv
                My.Settings.Theme = My.Resources.Calvv_C
            Case 108
                Me.Screenshot.Image = My.Resources.Excision
                My.Settings.Theme = My.Resources.Excision_C
            Case 109
                Me.Screenshot.Image = My.Resources.Green
                My.Settings.Theme = My.Resources.Green_C
            Case 110
                Me.Screenshot.Image = My.Resources.Paladin
                My.Settings.Theme = My.Resources.Paladin_C
            Case 111
                Me.Screenshot.Image = My.Resources.Storm
                My.Settings.Theme = My.Resources.Storm_C
            Case 112
                Me.Screenshot.Image = My.Resources.Vs
                My.Settings.Theme = My.Resources.Vs_C

        End Select
#End Region
    End Sub

    Private Sub btn_sourcecode_Click(sender As Object, e As EventArgs) Handles btn_sourcecode.Click
        If My.Settings.Theme = "" Or My.Settings.Theme = "empty" Then
            MsgBox("Please select or reselect any theme.", MsgBoxStyle.Exclamation, "Warning: Can't open source")

        Else

            sourcecode.Close()
            sourcecode.Show()

        End If
    End Sub

    Private Sub btn_copysource_Click(sender As Object, e As EventArgs) Handles btn_copysource.Click
        If My.Settings.Theme = "" Or My.Settings.Theme = "empty" Then
            MsgBox("Please select or reselect any theme.", MsgBoxStyle.Exclamation, "Warning: Can't copy")

        Else

            Label23.Visible = True
            Label23.ForeColor = Color.Yellow
            Label23.Text = "Copying.."
            Threading.Thread.Sleep(500)
            My.Computer.Clipboard.SetText("" & My.Settings.Theme)
            t_delay_copy.Interval = 3000
            t_delay_copy.Start()
            Label23.ForeColor = Color.Green
            Label23.Text = "Copied."

        End If
    End Sub

    Private Sub btn_generatebase_Click(sender As Object, e As EventArgs) Handles btn_generatebase.Click
        If rbtn_oldbase.Checked = False And rbtn_newbase.Checked = False Then
            FastColoredTextBox1.Text = "'Please select a Theme Base."

        Else

            If rbtn_oldbase.Checked = True Then
                FastColoredTextBox1.Text = My.Resources.Base_153

            Else

                FastColoredTextBox1.Text = My.Resources.Base_154

            End If
        End If
    End Sub

    Private Sub Label16_Click(sender As Object, e As EventArgs) Handles Label16.Click
        Process.Start("https://theme-manager.xyz/support")

    End Sub

    Private Sub btn_changelog2_Click(sender As Object, e As EventArgs) Handles btn_changelog2.Click
        changelog.Show()

    End Sub

    Private Sub t_delay_copy_Tick(sender As Object, e As EventArgs) Handles t_delay_copy.Tick
        t_delay_copy.Stop()
        Label23.Visible = False
        My.Settings.Theme = "empty"

    End Sub

    Private Sub btn_addfavo_Click(sender As Object, e As EventArgs) Handles btn_addfavo.Click
        If ListBox1.SelectedItem = Nothing Then
            MsgBox("Please click on a theme to add it to your favorites.", MsgBoxStyle.Information, "Information: Favorites")

        Else

            Dim liste As New System.Collections.Specialized.StringCollection

            For Each eintrag As String In ListBox1.Items
                liste.Add(eintrag)
            Next
            My.Settings.favorites = liste
            My.Settings.Save()
        End If

    End Sub
End Class
