﻿Imports System.Windows.Forms
Imports System.ComponentModel
Imports System.Net

Public Class UpdateDL
    Dim WithEvents downloader As New WebClient
    Dim path As String = My.Computer.FileSystem.SpecialDirectories.Desktop & "\Theme Manager_Updated.zip"

    Private Sub UpdateDL_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.TopMost = True

        '---
        Try

            downloader = New WebClient
            downloader.DownloadFileAsync(New Uri(url.Text), path)

        Catch ex As Exception
            MsgBox("Unexpected Error occurred. Please open a ticket with the following error here: https://theme-manager.xyz/support" + vbNewLine + vbNewLine + vbNewLine + ex.Message, MsgBoxStyle.Critical, "Unexpected Error - Theme Manager")

        End Try
    End Sub

    Private Sub downloader_DownloadProgressChanged(sender As Object, e As DownloadProgressChangedEventArgs) Handles downloader.DownloadProgressChanged
        ProgressBar1.Value = e.ProgressPercentage
        status.Text = "(" & e.ProgressPercentage & "%)"

    End Sub

    Private Sub downloader_DownloadFileCompleted(sender As Object, e As AsyncCompletedEventArgs) Handles downloader.DownloadFileCompleted
        status.Text = "Ready To Start"
        MsgBox("Download successfully." + vbNewLine + "Press 'OK' to close the old version of the Theme Manager.", MsgBoxStyle.Information, "Information: Successfully updated")
        Me.Hide()
        Form1.Hide()

        Dim qes = MessageBox.Show("Do you want to open the *.zip archive?", "Question: Yes/No", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
        If qes = DialogResult.No Then
            Form1.Close()
            Me.Close()
        End If

        If qes = DialogResult.Yes Then
            Process.Start(path)
            Form1.Close()
            Me.Close()

        End If
    End Sub
End Class
